/**
 * Copyright (c) 2021 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "sandboxscene.h"

bool sandboxSceneInit(sandboxscene_t *game) {
  // Init Assets
  assetShaderLoad(&game->shader,
    "shared/shaders/textured.vert",
    "shared/shaders/textured.frag"
  );
  assetFontLoad(&game->font, "shared/fonts/opensans/OpenSans-Regular.ttf");
  assetTextureLoad(&game->texture, "shared/test_texture.png");
  
  return true;
}

void sandboxSceneUpdate(sandboxscene_t *game) {
  camera_t camera;

  shaderUse(&game->shader);
  cameraOrtho(&camera,
    0, game->engine.render.width,
    game->engine.render.height, 0,
    0.01f, 1000.0f
  );
  cameraLookAt(&camera, 0,0,10, 0,0,0);
  shaderUseCamera(&game->shader, &camera);
}

void sandboxSceneDispose(sandboxscene_t *game) {
  // shaderDispose(&game->shader);
}